# Het handboek van &kdesu;

&Geert.Jansen; &Geert.Jansen.mail;
&Niels.Reedijk;&Rinse.Devries;
2000
&Geert.Jansen;
&FDLNotice;
2005-06-07
1.00.00

&kdesu; is een grafische schil voor het &UNIX;-commando `su`.

KDE
su
wachtwoord
root

## Inleiding

Welkom bij &kdesu;! &kdesu; is een grafische schil voor het UNIX-commando `su` voor de K Desktop Environment. Hiermee kunt u een programma als een andere gebruiker draaien door het wachtwoord voor die gebruiker in te voeren. &kdesu; doet zelf niets; het gebruikt het commando `su` van het systeem.

&kdesu; heeft één bijkomstige mogelijkheid: het kan wachtwoorden voor u onthouden. Als u deze mogelijkheid gebruikt, hoeft u het wachtwoord slechts één keer voor elk commando in te typen. Zie voor meer informatie hierover en een beveiligingsanalyse.

Dit programma dient te worden gestart vanaf de commandoregel of vanuit `.desktop`-bestanden. Hoewel het root-wachtwoord via een &GUI; dialoogvenster wordt gevraagd, wordt het meer als commandoregel <-> &GUI;-lijm, in plaats van een puur &GUI;-programma, gezien.

## &kdesu; gebruiken

Het gebruik van &kdesu; is makkelijk. De syntaxis is als volgt:

    kdesu -c -d -f  bestand -i  pictogramnaam -n -p  prioriteit -r -s -t -u  gebruiker --nonewdcop opdracht arg1 arg2

    kdesu algemene &kde;-opties algemene Qt-opties

De commandoregelopties zijn hieronder uitgelegd.

`-c programma`

  Dit specificeert het programma dat gedraaid zal worden als root. Er moet één argument in. Dus, als u, bijvoorbeeld, een nieuwe bestandsbeheerder wilt starten, kunt u op de prompt het volgende invoeren: ``kdesu `-c konqueror```

`-d`

  Geef debuginformatie weer.

`-f bestand`

  Met deze optie kunt u &kdesu; efficiënt gebruiken in `.desktop` bestanden. Het vertelt &kdesu; om het bestand gespecificeerd door de `bestand` te lezen. Als dit bestand schrijfbaar is door de huidige gebruiker, zal &kdesu; het commando als de huidige gebruiker uitvoeren. Als het niet schrijfbaar is, zal het commando uitgevoerd worden door de gebruiker `gebruiker` (standaard is dat root).

  `bestand` wordt op de volgende manier bekeken: als `bestand` met een "/" begint, wordt het gezien als een bestandsnaam. Anders wordt het gezien als de naam van een globaal &kde;-configuratiebestand. Bijvoorbeeld: om de K Display Manager, kdm, in te stellen voert u het volgende commando in: `kdesu `-c kdmconfig -f kdmrc``

`-i` pictogramnaam

  Geeft het pictogram op dat in het wachtwoordvenster gebruikt moet worden. U kunt volstaan met de naam zonder extensie.

  Bijvoorbeeld, om `kfmclient` te starten en het &konqueror;-pictogram in het wachtwoordvenster te tonen:

      kdesu  -i konqueror kfmclient

`-n`

  Sla het wachtwoord niet op. Dit schakelt het keuzevakje Wachtwoord onthouden in het dialoogvenster uit.

`-p` prioriteit

  Stel de prioriteit in. De prioriteit is een getal tussen 0 en 100, met 100 als hoogste prioriteit en 0 als laagste. De standaard is 50.

`-r`

  Gebruik realtime-scheduling.

`-s`

  Stop de kdesu daemon. zie .

`-t`

  Schakelt terminaluitvoer in. Dit schakelt het bewaren van wachtwoorden uit. Dit is vooral voor debugdoeleinden; als u een consolemode programma wilt draaien, gebruik dan het standaardcommando `su`.

`-u` gebruiker

  Hoewel &kdesu; het meest gebruikt wordt om een commando als hoofdgebruiker (root) te starten, kunt u elke gebruikersnaam met bijbehorend wachtwoord opgeven

## Onder de motorkap

### X-authenticatie

Het programma dat u uitvoert zal gedraaid worden onder de gebruikers-id root en zal in het algemeen geen toegang hebben tot uw grafische interface (X-display). &kdesu; werkt hier omheen door een authenticatie cookie voor uw scherm toe te voegen aan een tijdelijk `.Xauthority` bestand. Nadat het commando is beëindigd zal het bestand verwijderd worden.

Als u geen gebruik maakt van X-cookies, dan staat u er alleen voor. &kdesu; zal dit opmerken en geen cokie toevoegen. U dient er dan zelf voor te zorgen dat root toegang hefet tot uw grafische omgeving.

### Interface voor `su`

&kdesu; gebruikt het commando `su` van het systeem om de privileges te verkrijgen. In deze sectie wordt uitgelegd hoe &kdesu; dit doet.

Omdat sommige `su`-implementaties (zoals die van &RedHat;) het wachtwoord niet van de `stdin` willen lezen, zal &kdesu; een pty/tty-paar aanmaken en zal het `su` met zijn standaard bestandsdescriptors van daaruit oproepen.

Om een door de gebruiker geselecteerd commando uit te voeren in plaats van een interactieve shell, gebruikt &kdesu; het `-c` argument met `su`. Dit argument wordt ondersteund door elke shell die bestaat en is dus platformonafhankelijk. `su` geeft dit `-c` argument aan de shell van de doelgebruiker door en de shell zal het programma uitvoeren. Bijvoorbeeld: `su `root -c het_programma``.

In plaats van het gebruikerscommando direct uit te voeren met `su`, draait &kdesu; een klein stub-programmaatje genaamd kdesu_stub. Deze stub (draaiend als de doelgebruiker), vraagt wat informatie van &kdesu; over het pty/tty-kanaal (de stdin en de stdout van de stub) en draait dan het gebruikersprogramma. De informatie die overgebracht wordt is: de X-display, een X-authenticatie-cookie (als deze beschikbaar is), de `PATH` en het uit te voeren commando. De reden waarom een stub -programma wordt gebruikt is dat het cookie geheime informatie bevat en daarom niet over de commandoregel mag doorgegeven worden.

### Wachtwoordcontrole

&kdesu; zal het wachtwoord dat u ingevoerd hebt controleren en geeft een foutmelding als het niet correct is. De controle wordt uitgevoerd door een testprogramma: `/bin/true`. Als deze succesvol is, is het wachtwoord correct.

### Wachtwoord onthouden

Voor uw gemak implementeert &kdesu; de functie wachtwoord onthouden functie. Als u geïnteresseerd bent in beveiliging, lees dan deze alinea.

Als u &kdesu; wachtwoorden laat onthouden opent u een (klein) beveiligingsgat in uw systeem. Het is duidelijk dat &kdesu; niet iemand anders dan uw eigen gebruikers-id toestaat om de wachtwoorden te gebruiken, maar, als het zonder voorzichtigheid gedaan is, zal dit de beveiliging van root verlagen tot het niveau van een normale gebruiker (u). Een cracker die in uw account breekt zal dan root-toegang kunnen krijgen. &kdesu; probeert dit te voorkomen. Het beveiligingsschema dat wordt gebruikt, is in onze ogen vrij veilig en wordt hieronder uitgelegd.

&kdesu; gebruikt een daemon, genaamd kdesud. De daemon luistert voor commando's naar een &UNIX;-socket in `/tmp`. De mode van de socket is 0600, zodat alleen uw gebruikers-id ermee kan verbinden. Als wachtwoorden onthouden is ingeschakeld zal &kdesu; commando's uitvoeren door deze daemon. Het schrijft het commando en het root-wachtwoord naar de socket en de daemon voert het commando uit met behulp van `su`, zoals hierboven is omschreven. Hierna worden het commando en het wachtwoord niet weggegooid. Ze worden voor een bepaalde tijd bewaard. Dit is de tijdslimietwaarde in de configuratiemodule. Als een andere oproep voor hetzelfde commando in deze periode gedaan wordt zal de client het wachtwoord niet hoeven te geven. Om crackers die in uw account gebroken hebben niet de wachtwoorden van de daemon te laten stelen (bijvoorbeeld, door middel van een debugger), is de daemon geïnstalleerd in set-group-id nogroup. Dit zal ervoor zorgen dat alle normale gebruikers (inclusief u) geen wachtwoorden uit het kdesud -roces kunnen halen. De daemon zet ook de `DISPLAY` omgevingsvariabele gelijk aan de waarde die het had toen het gestart werd. Het enige dat een cracker kan doen is een programma in het huidige scherm uitvoeren.

Een zwakke plek in dit schema is dat programma's die u uitvoert waarschijnlijk niet geschreven zijn met beveiliging in gedachte (zoals bij setuid root programma's). Dit betekent dat ze buffer overruns of andere problemen zouden kunnen hebben waarvan een cracker gebruik kan maken.

Het gebruik van de functie wachtwoord onthouden is een afweging van comfort tegen beveiliging. Wij adviseren u om er goed over na te denken en om zelf te besluiten of u het al dan niet wilt gebruiken.

## Auteur

&kdesu;

Copyright 2000 &Geert.Jansen;

&kdesu; is geschreven door &Geert.Jansen;. Het is min of meer gebaseerd op Pietro Iglio's &kdesu;, versie 0.3. Pietro en ik besloten dat ik dit programma in de toekomst zal onderhouden.

De auteur kan bereikt worden via e-mail op &Geert.Jansen.mail;. Rapporteer alstublieft fouten zodat ik ze kan repareren. als u een suggestie heeft, neem dan alstublieft contact met mij op.

&underFDL; &underArtisticLicense;